//#include <Carbon.h>
#include <gl.h>
#include <string.h>
#include "CFM_Bridge.h"
#include "CFM_AGL_Bridge.h"

// Code for getting procedure pointers for agl
CFBundleRef gBundleRefAGL = NULL;

// ==========================

// Specific missing entry point support code

OSStatus InitMissingAGLEntryPoints (void);
void DeallocMissingAGLEntryPoints (void);

// function pointer declarations
// Note: One could use the exact entry point names but it would have mulitply defined symbols in Mac OS X 10.2 and later
//       pfXXX is chosen to represent 'pointer to function'
// AGL Interface
aglSurfaceTexturePtr pfaglSurfaceTexture = NULL;
aglCreatePBufferPtr pfaglCreatePBuffer = NULL;
aglDestroyPBufferPtr pfaglDestroyPBuffer = NULL;
aglDescribePBufferPtr pfaglDescribePBuffer = NULL;
aglTexImagePBufferPtr pfaglTexImagePBuffer = NULL;
aglSetPBufferPtr pfaglSetPBuffer = NULL;
aglGetPBufferPtr pfaglGetPBuffer = NULL;
	
// ==========================

OSStatus InitMissingAGLEntryPoints (void)
{
	OSStatus err;
	err = initEntryPoints (CFSTR("AGL.framework"), &gBundleRefAGL);	// init bundle
	if (noErr == err) {
		pfaglSurfaceTexture = (aglSurfaceTexturePtr) getProcAddress (CFSTR("aglSurfaceTexture"), &gBundleRefAGL);
		pfaglCreatePBuffer = (aglCreatePBufferPtr) getProcAddress (CFSTR("aglCreatePBuffer"), &gBundleRefAGL);
		pfaglDestroyPBuffer = (aglDestroyPBufferPtr) getProcAddress (CFSTR("aglDestroyPBuffer"), &gBundleRefAGL);
		pfaglDescribePBuffer = (aglDescribePBufferPtr) getProcAddress(CFSTR("aglDescribePBuffer"), &gBundleRefAGL);
		pfaglTexImagePBuffer = (aglTexImagePBufferPtr) getProcAddress(CFSTR("aglTexImagePBuffer"), &gBundleRefAGL);
		pfaglSetPBuffer = (aglSetPBufferPtr) getProcAddress(CFSTR("aglSetPBuffer"), &gBundleRefAGL);
		pfaglGetPBuffer = (aglGetPBufferPtr) getProcAddress(CFSTR("aglGetPBuffer"), &gBundleRefAGL);		
	}
	return err;
}

// -------------------------

void DeallocMissingAGLEntryPoints (void)
{
	pfaglSurfaceTexture = NULL;
	pfaglCreatePBuffer = NULL;
	pfaglDestroyPBuffer = NULL;
	pfaglDescribePBuffer = NULL;
	pfaglTexImagePBuffer = NULL;
	pfaglSetPBuffer = NULL;
	pfaglGetPBuffer = NULL;
	
	deallocEntryPoints (&gBundleRefAGL); // dump bundle
}
